<html>
<head>
<title>OgreD3D11HLSLProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11HLSLProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11HLSLProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11HLSLProgram_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11HLSLProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgram_8h.html">OgreHighLevelGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11VertexDeclaration_8h.html">OgreD3D11VertexDeclaration.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a><a class="code" href="namespaceOgre.html#a00d4a79ab9d0df3408d7a15be1e31d9a">00037</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;byte&gt;::type</a> <a class="code" href="namespaceOgre.html#a00d4a79ab9d0df3408d7a15be1e31d9a">MicroCode</a>;
<a name="l00038"></a>00038 
<a name="l00047"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html">00047</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram.html" title="Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL)...">D3D11HLSLProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEntryPoint.html">00051</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00052"></a>00052         {
<a name="l00053"></a>00053         <span class="keyword">public</span>:
<a name="l00054"></a>00054             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEntryPoint.html#a1d3492c9cb07170495f3d47e165e1518">doGet</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00055"></a>00055             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEntryPoint.html#a9f0d48c03f66a34d482b79601bb523f0">doSet</a>(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00056"></a>00056         };
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdTarget.html">00058</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdTarget.html" title="Command object for setting target assembler.">CmdTarget</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00059"></a>00059         {
<a name="l00060"></a>00060         <span class="keyword">public</span>:
<a name="l00061"></a>00061             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdTarget.html#a8dde41c9964ba91153ad482087294c35">doGet</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00062"></a>00062             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdTarget.html#ac21e0839a9d4c426102a0c6a10fe34d6">doSet</a>(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00063"></a>00063         };
<a name="l00065"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdPreprocessorDefines.html">00065</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00066"></a>00066         {
<a name="l00067"></a>00067         <span class="keyword">public</span>:
<a name="l00068"></a>00068             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdPreprocessorDefines.html#a1b72ddd6f6fae201665a091d060ddcfa">doGet</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00069"></a>00069             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdPreprocessorDefines.html#aca081c88b56c74b66169930d6d89831c">doSet</a>(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00070"></a>00070         };
<a name="l00072"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdColumnMajorMatrices.html">00072</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074         <span class="keyword">public</span>:
<a name="l00075"></a>00075             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdColumnMajorMatrices.html#a7228cb757f7b7dbce2fa6f430a891a19">doGet</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00076"></a>00076             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdColumnMajorMatrices.html#ae49ebe5cd4e7c2a11b74e3d0e7465941">doSet</a>(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00077"></a>00077         };
<a name="l00079"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEnableBackwardsCompatibility.html">00079</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEnableBackwardsCompatibility.html" title="Command object for setting backwards compatibility.">CmdEnableBackwardsCompatibility</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081         <span class="keyword">public</span>:
<a name="l00082"></a>00082             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEnableBackwardsCompatibility.html#a97d38e6d9e894d97f077d80581f88cce">doGet</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* target) <span class="keyword">const</span>;
<a name="l00083"></a>00083             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEnableBackwardsCompatibility.html#a06df9b64337969a8dbeb0287b976ab47">doSet</a>(<span class="keywordtype">void</span>* target, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; val);
<a name="l00084"></a>00084         };
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     <span class="keyword">protected</span>:
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a6f8db1ecb544fbaa82b9d4dd69eae2fe">00088</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEntryPoint.html" title="Command object for setting entry point.">CmdEntryPoint</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a6f8db1ecb544fbaa82b9d4dd69eae2fe">msCmdEntryPoint</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abb70c71db2906a37f391b47ada496e17">00089</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdTarget.html" title="Command object for setting target assembler.">CmdTarget</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abb70c71db2906a37f391b47ada496e17">msCmdTarget</a>;
<a name="l00090"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ae99157d110ffc2baf798660474d90d9e">00090</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdPreprocessorDefines.html" title="Command object for setting macro defines.">CmdPreprocessorDefines</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ae99157d110ffc2baf798660474d90d9e">msCmdPreprocessorDefines</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a87ffdfaa843db3d87eed3be8b569b96c">00091</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdColumnMajorMatrices.html" title="Command object for setting matrix packing in column-major order.">CmdColumnMajorMatrices</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a87ffdfaa843db3d87eed3be8b569b96c">msCmdColumnMajorMatrices</a>;
<a name="l00092"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a71e38fab8a618332f2b0da37dee1e1e3">00092</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram_1_1CmdEnableBackwardsCompatibility.html" title="Command object for setting backwards compatibility.">CmdEnableBackwardsCompatibility</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a71e38fab8a618332f2b0da37dee1e1e3">msCmdEnableBackwardsCompatibility</a>;
<a name="l00093"></a>00093         
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a0cad34d74fc7027f80b72c3fcedf17b7" title="Internal method for creating an appropriate low-level program from this high-level program...">createLowLevelImpl</a>(<span class="keywordtype">void</span>);
<a name="l00099"></a>00099         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a879428b8e3698b922f039800229ca546" title="Internal unload implementation, must be implemented by subclasses.">unloadHighLevelImpl</a>(<span class="keywordtype">void</span>);
<a name="l00101"></a>00101         <span class="comment">//void populateParameterNames(GpuProgramParametersSharedPtr params);</span>
<a name="l00102"></a>00102 
<a name="l00103"></a>00103         <span class="comment">// Recursive utility method for populateParameterNames</span>
<a name="l00104"></a>00104         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#adf7c4fff85b37a2a1c6595cf6cacd589" title="Populate the passed parameters with name-&gt;index map, must be overridden.">processParamElement</a>(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> prefix, LPCSTR pName, <span class="keywordtype">size_t</span> paramIndex, ID3D11ShaderReflectionType* varRefType) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aa02ed1c90b0d9da3f6bb885028134d7c">populateDef</a>(D3D11_SHADER_TYPE_DESC&amp; d3dDesc, <a class="code" href="structOgre_1_1GpuConstantDefinition.html" title="Information about predefined program constants.">GpuConstantDefinition</a>&amp; def) <span class="keyword">const</span>;
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a70886b53d933370ee1aa79f6cb9579de">00108</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a70886b53d933370ee1aa79f6cb9579de">mTarget</a>;
<a name="l00109"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aabfa28b438f0c9f1dfbbaa353fd35bdd">00109</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aabfa28b438f0c9f1dfbbaa353fd35bdd">mEntryPoint</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac3295c4ac85c1b328e4913d68e53da99">00110</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac3295c4ac85c1b328e4913d68e53da99">mPreprocessorDefines</a>;
<a name="l00111"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a13d41b7c7b81e502b0d544ba1f4320bf">00111</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a13d41b7c7b81e502b0d544ba1f4320bf">mColumnMajorMatrices</a>;
<a name="l00112"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a007b2236b1669523f8e0239aa753dc53">00112</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a007b2236b1669523f8e0239aa753dc53">mEnableBackwardsCompatibility</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a2388be8698e64bea2c97454b2fdc5cd2">00114</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a2388be8698e64bea2c97454b2fdc5cd2">mErrorsInCompile</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#afe8943753562a7b48ac4665272534bc2">00115</a>         <a class="code" href="namespaceOgre.html#a00d4a79ab9d0df3408d7a15be1e31d9a">MicroCode</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#afe8943753562a7b48ac4665272534bc2">mMicroCode</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a5e584bac204f3cdf97739a235ebbb1d0">00116</a>         ID3D11Buffer* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a5e584bac204f3cdf97739a235ebbb1d0">mConstantBuffer</a>;
<a name="l00117"></a>00117         
<a name="l00118"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a63136f6326057b05ab3b7adbe14f0f42">00118</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a63136f6326057b05ab3b7adbe14f0f42">mDevice</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a7bad692a13b3335893cefc5e310cb652">00120</a>         ID3D11ShaderReflectionConstantBuffer* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a7bad692a13b3335893cefc5e310cb652">mShaderReflectionConstantBuffer</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abe392cd985a8dace0809ab9c5e175c30">00121</a>         D3D11_SHADER_BUFFER_DESC <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abe392cd985a8dace0809ab9c5e175c30">mConstantBufferDesc</a> ;
<a name="l00122"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a0627dcb109b38861333ef5099f9d896a">00122</a>         D3D11_SHADER_DESC <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a0627dcb109b38861333ef5099f9d896a">mShaderDesc</a>;
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a8315e313897694edf0903757cb9b30cb">00124</a>         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D11.">D3D11VertexDeclaration</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a8315e313897694edf0903757cb9b30cb">mInputVertexDeclaration</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3090379256cf6c08bb67a38bbebebf46">00126</a>         ID3D11ShaderReflection* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3090379256cf6c08bb67a38bbebebf46">mIShaderReflection</a>;
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a33bcc5bc2bc1a9e2e736e813875c8066">00128</a>         ID3D11VertexShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a33bcc5bc2bc1a9e2e736e813875c8066">mVertexShader</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af747fcb5d5146fb340a67afb3c13c5d3">00129</a>         ID3D11PixelShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af747fcb5d5146fb340a67afb3c13c5d3">mPixelShader</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3851676fc94af65c5cd2089644568de3">00130</a>         ID3D11GeometryShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3851676fc94af65c5cd2089644568de3">mGeometryShader</a>;
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html">00132</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html">ShaderVarWithPosInBuf</a>
<a name="l00133"></a>00133         {
<a name="l00134"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ae32799df8656262933360e02731189b1">00134</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ae32799df8656262933360e02731189b1">wasInit</a>;
<a name="l00135"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ae6ea292b852a262479065940b78906c1">00135</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ae6ea292b852a262479065940b78906c1">isFloat</a>;
<a name="l00136"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ac2db5b9477ed12e67115a8866353fc42">00136</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ac2db5b9477ed12e67115a8866353fc42">physicalIndex</a>;
<a name="l00137"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#a25986130fe99c0f3e72d312d21df719c">00137</a>             <span class="keywordtype">void</span> * <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#a25986130fe99c0f3e72d312d21df719c">src</a>;
<a name="l00138"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ac5bd2e87c1cf5231aee189ffa51b40f1">00138</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#ac5bd2e87c1cf5231aee189ffa51b40f1">name</a>;
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#aa5b190c51bf446eed7a97d443fdc05ea">00140</a>             D3D11_SHADER_VARIABLE_DESC <a class="code" href="structOgre_1_1D3D11HLSLProgram_1_1ShaderVarWithPosInBuf.html#aa5b190c51bf446eed7a97d443fdc05ea">var</a>;
<a name="l00141"></a>00141         };
<a name="l00142"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a731f6e52fa94c821f62b71e3dfd44fa8">00142</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ShaderVarWithPosInBuf&gt;::type</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a731f6e52fa94c821f62b71e3dfd44fa8">ShaderVars</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aab5ba47ae84bb1657a24118d5c9ab0ab">00143</a>         <span class="keyword">typedef</span> ShaderVars::iterator <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aab5ba47ae84bb1657a24118d5c9ab0ab">ShaderVarsIter</a>; 
<a name="l00144"></a>00144 
<a name="l00145"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac491ba45fdd29e007f2ec4152257aadd">00145</a>         <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a731f6e52fa94c821f62b71e3dfd44fa8">ShaderVars</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac491ba45fdd29e007f2ec4152257aadd">mShaderVars</a>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a8dd4641d4ad022bfbe1417d14007b63a">createConstantBuffer</a>(<span class="keyword">const</span> UINT ByteWidth);
<a name="l00148"></a>00148         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3013c3ac2c01fe0f57ed380c37fa72a7">analizeMicrocode</a>();
<a name="l00149"></a>00149         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abedc74fcd53c47138fe4e28fc27504c3">getMicrocodeFromCache</a>(<span class="keywordtype">void</span>);
<a name="l00150"></a>00150         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a7957298a086fcfeb7795cc06c61b7ca5">compileMicrocode</a>(<span class="keywordtype">void</span>);
<a name="l00151"></a>00151     <span class="keyword">public</span>:
<a name="l00152"></a>00152         <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a85d86c3f9168e361c57a53305c985683">D3D11HLSLProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00153"></a>00153             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00154"></a>00154         <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aabc74a1b85c3201520034773e438dce4">~D3D11HLSLProgram</a>();
<a name="l00155"></a>00155 
<a name="l00157"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac2413285a4ce23815075691179c17740">00157</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac2413285a4ce23815075691179c17740" title="Sets the entry point for this program ie the first method called.">setEntryPoint</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; entryPoint) { <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aabfa28b438f0c9f1dfbbaa353fd35bdd">mEntryPoint</a> = entryPoint; }
<a name="l00159"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a02220316762b21c7bff8e49ea9a46107">00159</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a02220316762b21c7bff8e49ea9a46107" title="Gets the entry point defined for this program.">getEntryPoint</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aabfa28b438f0c9f1dfbbaa353fd35bdd">mEntryPoint</a>; }
<a name="l00161"></a>00161         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a005406c10274350b82ccec0092e9b53c" title="Sets the shader target to compile down to, e.g.">setTarget</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; target);
<a name="l00163"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#adee16da6089f4d844ae3aea36cba1481">00163</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#adee16da6089f4d844ae3aea36cba1481" title="Gets the shader target to compile down to, e.g.">getTarget</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a70886b53d933370ee1aa79f6cb9579de">mTarget</a>; }
<a name="l00164"></a>00164 
<a name="l00166"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a9305d93d797b39e4f69fa55dbaed1e87">00166</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a9305d93d797b39e4f69fa55dbaed1e87" title="Sets the preprocessor defines use to compile the program.">setPreprocessorDefines</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; defines) { <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac3295c4ac85c1b328e4913d68e53da99">mPreprocessorDefines</a> = defines; }
<a name="l00168"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af22c65d4959f6569fe086f5decb48c3c">00168</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af22c65d4959f6569fe086f5decb48c3c" title="Sets the preprocessor defines use to compile the program.">getPreprocessorDefines</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac3295c4ac85c1b328e4913d68e53da99">mPreprocessorDefines</a>; }
<a name="l00170"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ae504a6cf2f2f705a50a9066b5ea819df">00170</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ae504a6cf2f2f705a50a9066b5ea819df" title="Sets whether matrix packing in column-major order.">setColumnMajorMatrices</a>(<span class="keywordtype">bool</span> columnMajor) { <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a13d41b7c7b81e502b0d544ba1f4320bf">mColumnMajorMatrices</a> = columnMajor; }
<a name="l00172"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a7841e8d2a4046bc74eb92e45f37b53ea">00172</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a7841e8d2a4046bc74eb92e45f37b53ea" title="Gets whether matrix packed in column-major order.">getColumnMajorMatrices</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a13d41b7c7b81e502b0d544ba1f4320bf">mColumnMajorMatrices</a>; }
<a name="l00174"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af65bb4a977838157faf9abb3e63f2233">00174</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#af65bb4a977838157faf9abb3e63f2233" title="Sets whether backwards compatibility is enabled.">setEnableBackwardsCompatibility</a>(<span class="keywordtype">bool</span> enableBackwardsCompatibility) { <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a007b2236b1669523f8e0239aa753dc53">mEnableBackwardsCompatibility</a> = enableBackwardsCompatibility; }
<a name="l00176"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a4eb07294889afd79209921a75f4bd359">00176</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a4eb07294889afd79209921a75f4bd359" title="Gets whether backwards compatibility is enabled.">getEnableBackwardsCompatibility</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a007b2236b1669523f8e0239aa753dc53">mEnableBackwardsCompatibility</a>; }
<a name="l00178"></a>00178         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ae904f2ffde21cdf2c64f4124b6a63bff" title="Overridden from GpuProgram.">isSupported</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00180"></a>00180         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ad8388ee6585a2e9d546de0fb5a0644e3" title="Overridden from GpuProgram.">createParameters</a>(<span class="keywordtype">void</span>);
<a name="l00182"></a>00182         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a34c77b37d0a8a528d8187823cb256ddf" title="Overridden from GpuProgram.">getLanguage</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ac2716425282dfac258622d444e89216d" title="Build the constant definition map, must be overridden.">buildConstantDefinitions</a>() <span class="keyword">const</span>;
<a name="l00185"></a>00185         ID3D11VertexShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#ab0286cab9210aebf53a49f1ab6b07965">getVertexShader</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00186"></a>00186         ID3D11PixelShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#acf889e4ae213da85f9001502b001a0d7">getPixelShader</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>; 
<a name="l00187"></a>00187         ID3D11GeometryShader* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a96be8cc1ff362a13a2fd29346174b66a">getGeometryShader</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>; 
<a name="l00188"></a>00188         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a00d4a79ab9d0df3408d7a15be1e31d9a">MicroCode</a> &amp;  <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#abb712d12b54cf28163b132c274cc41e9">getMicroCode</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;  
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         ID3D11Buffer* <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a738bcf735758cf75ed6bfcfdc1d926bf">getConstantBuffer</a>(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variabilityMask);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a1bc38936aa3d9ef3ab59ec75fcba768c">CreateVertexShader</a>();
<a name="l00193"></a>00193         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aff5bc7363bd68cfdf653e380e68904d4">CreatePixelShader</a>();
<a name="l00194"></a>00194         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#aa3f8f2a3458a62735f55c39d153a99db">CreateGeometryShader</a>();
<a name="l00195"></a>00195 
<a name="l00198"></a>00198         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a385cc4247bcc3625001cd3062bb9992b" title="Internal load implementation, must be implemented by subclasses.">loadFromSource</a>(<span class="keywordtype">void</span>);
<a name="l00199"></a>00199 
<a name="l00200"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a6c68c4ca4f6dc06c0ac1809f69e2fd9e">00200</a>         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D11.">D3D11VertexDeclaration</a> &amp; <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a6c68c4ca4f6dc06c0ac1809f69e2fd9e">getInputVertexDeclaration</a>() { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a8315e313897694edf0903757cb9b30cb">mInputVertexDeclaration</a>; }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a585368f2e75a4e78b36a4048a9300563">reinterpretGSForStreamOut</a>(<span class="keywordtype">void</span>);
<a name="l00203"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a9174dcd088c729234de410a0d640f090">00203</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a9174dcd088c729234de410a0d640f090">mReinterpretingGS</a>;
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a358f33e1d1d81314bc25876f0fddd4a3">00205</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a358f33e1d1d81314bc25876f0fddd4a3">getNumInputs</a>(<span class="keywordtype">void</span>)<span class="keyword">const </span>{<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a0627dcb109b38861333ef5099f9d896a">mShaderDesc</a>.InputParameters;}
<a name="l00206"></a><a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a213a5930357089b1cc9617ca2b3e9881">00206</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a213a5930357089b1cc9617ca2b3e9881">getNumOutputs</a>(<span class="keywordtype">void</span>)<span class="keyword">const </span>{<span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a0627dcb109b38861333ef5099f9d896a">mShaderDesc</a>.OutputParameters;}
<a name="l00207"></a>00207 
<a name="l00208"></a>00208         D3D11_SIGNATURE_PARAMETER_DESC <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a3ced17911026dcad84d3dee159cb606a">getInputParamDesc</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;
<a name="l00209"></a>00209         D3D11_SIGNATURE_PARAMETER_DESC <a class="code" href="classOgre_1_1D3D11HLSLProgram.html#a8f9e93b3795cd32a9474394a1a79ad27">getOutputParamDesc</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) <span class="keyword">const</span>;    
<a name="l00210"></a>00210     };
<a name="l00211"></a>00211 }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
